(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@ngx-translate/core'), require('narik-ui-core'), require('@angular/forms'), require('@angular/common'), require('narik-app-core'), require('narik-core'), require('narik-infrastructure'), require('narik-common'), require('@angular/animations'), require('angular2-uuid')) :
    typeof define === 'function' && define.amd ? define('narik-ui-ngx-bootstrap', ['exports', '@angular/core', '@ngx-translate/core', 'narik-ui-core', '@angular/forms', '@angular/common', 'narik-app-core', 'narik-core', 'narik-infrastructure', 'narik-common', '@angular/animations', 'angular2-uuid'], factory) :
    (global = global || self, factory(global['narik-ui-ngx-bootstrap'] = {}, global.ng.core, global.core$1, global.narikUiCore, global.ng.forms, global.ng.common, global.narikAppCore, global.narikCore, global.narikInfrastructure, global.narikCommon, global.ng.animations, global.angular2Uuid));
}(this, function (exports, core, core$1, narikUiCore, forms, common, narikAppCore, narikCore, narikInfrastructure, narikCommon, animations, angular2Uuid) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NarikNgxAutoComplete = /** @class */ (function (_super) {
        __extends(NarikNgxAutoComplete, _super);
        function NarikNgxAutoComplete() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        NarikNgxAutoComplete.decorators = [
            { type: core.Component, args: [{
                        selector: "narik-ngx-autocomplete  , narik-autocomplete ",
                        template: "",
                        inputs: __spread(narikUiCore.NARIK_DATA_DISPLAY_VALUE_INPUTS),
                        outputs: __spread(narikUiCore.NARIK_DATA_DISPLAY_VALUE_OUTPUTS),
                        providers: [
                            {
                                provide: forms.NG_VALUE_ACCESSOR,
                                useExisting: core.forwardRef((/**
                                 * @return {?}
                                 */
                                function () { return NarikNgxAutoComplete; })),
                                multi: true
                            }
                        ],
                        styles: [""]
                    }] }
        ];
        return NarikNgxAutoComplete;
    }(narikUiCore.NarikAutoComplete));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NarikNgxAutoCompleteModule = /** @class */ (function () {
        function NarikNgxAutoCompleteModule() {
        }
        NarikNgxAutoCompleteModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule, forms.FormsModule],
                        declarations: [NarikNgxAutoComplete],
                        exports: [NarikNgxAutoComplete],
                        providers: []
                    },] }
        ];
        return NarikNgxAutoCompleteModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NarikNgxBusyIndicator = /** @class */ (function () {
        function NarikNgxBusyIndicator() {
        }
        /**
         * @param {?} newState
         * @param {?=} msg
         * @return {?}
         */
        NarikNgxBusyIndicator.prototype.setBusy = /**
         * @param {?} newState
         * @param {?=} msg
         * @return {?}
         */
        function (newState, msg) {
            this.isBusy = newState;
        };
        NarikNgxBusyIndicator.decorators = [
            { type: core.Component, args: [{
                        selector: "narik-ngx-busy-indicator , narik-busy-indicator",
                        template: "\r\n",
                        providers: [
                            {
                                provide: narikAppCore.BusyIndicator,
                                useExisting: core.forwardRef((/**
                                 * @return {?}
                                 */
                                function () { return NarikNgxBusyIndicator; }))
                            }
                        ],
                        styles: [""]
                    }] }
        ];
        NarikNgxBusyIndicator.propDecorators = {
            isBusy: [{ type: core.Input }]
        };
        return NarikNgxBusyIndicator;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NarikNgxBusyIndicatorModule = /** @class */ (function () {
        function NarikNgxBusyIndicatorModule() {
        }
        NarikNgxBusyIndicatorModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule, core$1.TranslateModule],
                        declarations: [NarikNgxBusyIndicator],
                        exports: [NarikNgxBusyIndicator],
                        providers: []
                    },] }
        ];
        return NarikNgxBusyIndicatorModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NarikNgxButtonComponent = /** @class */ (function (_super) {
        __extends(NarikNgxButtonComponent, _super);
        function NarikNgxButtonComponent(renderer, injector) {
            var _this = _super.call(this, injector) || this;
            _this.renderer = renderer;
            return _this;
        }
        /**
         * @return {?}
         */
        NarikNgxButtonComponent.prototype.ngAfterViewInit = /**
         * @return {?}
         */
        function () { };
        NarikNgxButtonComponent.decorators = [
            { type: core.Component, args: [{
                        selector: "narik-ngx-buuton , narik-button ",
                        template: "\r\n"
                    }] }
        ];
        /** @nocollapse */
        NarikNgxButtonComponent.ctorParameters = function () { return [
            { type: core.Renderer2 },
            { type: core.Injector }
        ]; };
        __decorate([
            narikCore.NarikInject(narikUiCore.BUTTON_DEFAULT_OPTIONS, {
                buttonStyle: "mat-raised-button",
                busyFontIcon: "fa-spinner"
            }),
            __metadata("design:type", Object)
        ], NarikNgxButtonComponent.prototype, "defaultOptions", void 0);
        return NarikNgxButtonComponent;
    }(narikUiCore.NarikButton));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NarikNgxButtonModule = /** @class */ (function () {
        function NarikNgxButtonModule() {
        }
        NarikNgxButtonModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule],
                        declarations: [NarikNgxButtonComponent],
                        exports: [NarikNgxButtonComponent],
                        providers: []
                    },] }
        ];
        return NarikNgxButtonModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NarikNgxCheckBox = /** @class */ (function (_super) {
        __extends(NarikNgxCheckBox, _super);
        function NarikNgxCheckBox(injector) {
            return _super.call(this, injector) || this;
        }
        NarikNgxCheckBox.decorators = [
            { type: core.Component, args: [{
                        selector: "narik-ngx-checkbox , narik-checkbox",
                        template: "",
                        inputs: __spread(narikUiCore.NARIK_CHECKBOX_INPUTS),
                        providers: [
                            {
                                provide: forms.NG_VALUE_ACCESSOR,
                                useExisting: core.forwardRef((/**
                                 * @return {?}
                                 */
                                function () { return NarikNgxCheckBox; })),
                                multi: true
                            },
                            {
                                provide: narikUiCore.NarikCheckBox,
                                useExisting: core.forwardRef((/**
                                 * @return {?}
                                 */
                                function () { return NarikNgxCheckBox; }))
                            }
                        ]
                    }] }
        ];
        /** @nocollapse */
        NarikNgxCheckBox.ctorParameters = function () { return [
            { type: core.Injector }
        ]; };
        return NarikNgxCheckBox;
    }(narikUiCore.NarikCheckBox));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NarikNgxCheckBoxModule = /** @class */ (function () {
        function NarikNgxCheckBoxModule() {
        }
        NarikNgxCheckBoxModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule, forms.FormsModule],
                        declarations: [NarikNgxCheckBox],
                        exports: [NarikNgxCheckBox],
                        providers: []
                    },] }
        ];
        return NarikNgxCheckBoxModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NarikNgxCheckBoxList = /** @class */ (function (_super) {
        __extends(NarikNgxCheckBoxList, _super);
        function NarikNgxCheckBoxList(injector) {
            return _super.call(this, injector) || this;
        }
        NarikNgxCheckBoxList.decorators = [
            { type: core.Component, args: [{
                        selector: "narik-ngx-checkbox-list , narik-checkbox-list",
                        template: "\r\n",
                        inputs: __spread(narikUiCore.NARIK_DATA_DISPLAY_VALUE_INPUTS),
                        providers: [
                            {
                                provide: forms.NG_VALUE_ACCESSOR,
                                useExisting: core.forwardRef((/**
                                 * @return {?}
                                 */
                                function () { return NarikNgxCheckBoxList; })),
                                multi: true
                            }
                        ]
                    }] }
        ];
        /** @nocollapse */
        NarikNgxCheckBoxList.ctorParameters = function () { return [
            { type: core.Injector }
        ]; };
        return NarikNgxCheckBoxList;
    }(narikUiCore.NarikCheckBoxList));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NarikNgxCheckBoxListModule = /** @class */ (function () {
        function NarikNgxCheckBoxListModule() {
        }
        NarikNgxCheckBoxListModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [
                            common.CommonModule,
                            forms.FormsModule,
                            NarikNgxCheckBoxModule
                        ],
                        declarations: [NarikNgxCheckBoxList],
                        exports: [NarikNgxCheckBoxList],
                        providers: []
                    },] }
        ];
        return NarikNgxCheckBoxListModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NarikNgxDataTable = /** @class */ (function (_super) {
        __extends(NarikNgxDataTable, _super);
        function NarikNgxDataTable(injector, changeDetector, document) {
            var _this = _super.call(this, injector) || this;
            _this.changeDetector = changeDetector;
            _this.document = document;
            return _this;
        }
        NarikNgxDataTable.decorators = [
            { type: core.Component, args: [{
                        selector: "narik-ngx-data-table , narik-data-table",
                        template: ""
                    }] }
        ];
        /** @nocollapse */
        NarikNgxDataTable.ctorParameters = function () { return [
            { type: core.Injector },
            { type: core.ChangeDetectorRef },
            { type: undefined, decorators: [{ type: core.Inject, args: [common.DOCUMENT,] }] }
        ]; };
        return NarikNgxDataTable;
    }(narikUiCore.NarikDataTable));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NarikNgxDataTableModule = /** @class */ (function () {
        function NarikNgxDataTableModule() {
        }
        NarikNgxDataTableModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule, forms.FormsModule, core$1.TranslateModule],
                        declarations: [NarikNgxDataTable],
                        exports: [NarikNgxDataTable],
                        providers: []
                    },] }
        ];
        return NarikNgxDataTableModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NarikNgxDatePicker = /** @class */ (function (_super) {
        __extends(NarikNgxDatePicker, _super);
        function NarikNgxDatePicker(injector) {
            return _super.call(this, injector) || this;
        }
        NarikNgxDatePicker.decorators = [
            { type: core.Component, args: [{
                        selector: "narik-ngx-date-picker , narik-date-picker",
                        template: "\r\n",
                        inputs: __spread(narikUiCore.NARIK_DATE_PICKER_INPUTS),
                        providers: [
                            {
                                provide: forms.NG_VALUE_ACCESSOR,
                                useExisting: core.forwardRef((/**
                                 * @return {?}
                                 */
                                function () { return NarikNgxDatePicker; })),
                                multi: true
                            }
                        ]
                    }] }
        ];
        /** @nocollapse */
        NarikNgxDatePicker.ctorParameters = function () { return [
            { type: core.Injector }
        ]; };
        return NarikNgxDatePicker;
    }(narikUiCore.NarikDatePicker));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NarikNgxDatePickerModule = /** @class */ (function () {
        function NarikNgxDatePickerModule() {
        }
        NarikNgxDatePickerModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule, forms.FormsModule, core$1.TranslateModule],
                        declarations: [NarikNgxDatePicker],
                        exports: [NarikNgxDatePicker],
                        providers: []
                    },] }
        ];
        return NarikNgxDatePickerModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NarikNgxInput = /** @class */ (function (_super) {
        __extends(NarikNgxInput, _super);
        function NarikNgxInput(injector) {
            return _super.call(this, injector) || this;
        }
        NarikNgxInput.decorators = [
            { type: core.Component, args: [{
                        selector: "narik-ngx-input , narik-input",
                        template: "",
                        inputs: __spread(narikUiCore.NARIK_INPUT_INPUTS),
                        providers: [
                            {
                                provide: forms.NG_VALUE_ACCESSOR,
                                useExisting: core.forwardRef((/**
                                 * @return {?}
                                 */
                                function () { return NarikNgxInput; })),
                                multi: true
                            }
                        ]
                    }] }
        ];
        /** @nocollapse */
        NarikNgxInput.ctorParameters = function () { return [
            { type: core.Injector }
        ]; };
        return NarikNgxInput;
    }(narikUiCore.NarikInput));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NarikNgxInputModule = /** @class */ (function () {
        function NarikNgxInputModule() {
        }
        NarikNgxInputModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule, forms.FormsModule],
                        declarations: [NarikNgxInput],
                        exports: [NarikNgxInput],
                        providers: []
                    },] }
        ];
        return NarikNgxInputModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NarikNgxRadioGroup = /** @class */ (function (_super) {
        __extends(NarikNgxRadioGroup, _super);
        function NarikNgxRadioGroup(injector) {
            return _super.call(this, injector) || this;
        }
        NarikNgxRadioGroup.decorators = [
            { type: core.Component, args: [{
                        selector: "narik-ngx-radio-group , narik-radio-group",
                        template: "",
                        inputs: __spread(narikUiCore.NARIK_DATA_DISPLAY_VALUE_INPUTS),
                        providers: [
                            {
                                provide: forms.NG_VALUE_ACCESSOR,
                                useExisting: core.forwardRef((/**
                                 * @return {?}
                                 */
                                function () { return NarikNgxRadioGroup; })),
                                multi: true
                            }
                        ]
                    }] }
        ];
        /** @nocollapse */
        NarikNgxRadioGroup.ctorParameters = function () { return [
            { type: core.Injector }
        ]; };
        return NarikNgxRadioGroup;
    }(narikUiCore.NarikRadioGroup));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NarikNgxRadioGroupModule = /** @class */ (function () {
        function NarikNgxRadioGroupModule() {
        }
        NarikNgxRadioGroupModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule, forms.FormsModule],
                        declarations: [NarikNgxRadioGroup],
                        exports: [NarikNgxRadioGroup],
                        providers: []
                    },] }
        ];
        return NarikNgxRadioGroupModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NarikNgxSelect = /** @class */ (function (_super) {
        __extends(NarikNgxSelect, _super);
        function NarikNgxSelect(injector) {
            var _this = _super.call(this, injector) || this;
            _this.optionData = [];
            return _this;
        }
        /**
         * @protected
         * @param {?} data
         * @return {?}
         */
        NarikNgxSelect.prototype.useData = /**
         * @protected
         * @param {?} data
         * @return {?}
         */
        function (data) {
            this.optionData = data;
        };
        NarikNgxSelect.decorators = [
            { type: core.Component, args: [{
                        selector: "narik-ngx-select , narik-select",
                        template: "",
                        inputs: __spread(narikUiCore.NARIK_DATA_DISPLAY_VALUE_INPUTS, narikUiCore.NARIK_SELECT_INPUTS),
                        outputs: __spread(narikUiCore.NARIK_DATA_DISPLAY_VALUE_OUTPUTS),
                        providers: [
                            {
                                provide: forms.NG_VALUE_ACCESSOR,
                                useExisting: core.forwardRef((/**
                                 * @return {?}
                                 */
                                function () { return NarikNgxSelect; })),
                                multi: true
                            }
                        ],
                        styles: [".select-clear{position:absolute;left:-2px;top:-30px}.search-input{padding:16px;box-sizing:border-box}.search-continer{border-bottom:1px solid rgba(0,0,0,.12);top:0;width:100%;position:-webkit-sticky;position:sticky;background-color:#fff;z-index:10000}"]
                    }] }
        ];
        /** @nocollapse */
        NarikNgxSelect.ctorParameters = function () { return [
            { type: core.Injector }
        ]; };
        return NarikNgxSelect;
    }(narikUiCore.NarikSelect));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NarikNgxSelectModule = /** @class */ (function () {
        function NarikNgxSelectModule() {
        }
        NarikNgxSelectModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule, forms.FormsModule],
                        declarations: [NarikNgxSelect],
                        exports: [NarikNgxSelect],
                        providers: []
                    },] }
        ];
        return NarikNgxSelectModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NarikNgxDynamicForm = /** @class */ (function (_super) {
        __extends(NarikNgxDynamicForm, _super);
        function NarikNgxDynamicForm(injector, viewContainerRef) {
            return _super.call(this, injector, viewContainerRef) || this;
        }
        NarikNgxDynamicForm.decorators = [
            { type: core.Component, args: [{
                        selector: "narik-dynamic-form , narik-ngx-dynamic-form",
                        template: "<div\r\n  class=\"dx-fieldset\"\r\n  [tab-guard]=\"activeTabGuard\"\r\n  [auto-focus]=\"activeAutoFocus\"\r\n  [autoFocusContainerName]=\"defaultFocusField\"\r\n>\r\n  <ng-container *ngFor=\"let item of fields\">\r\n\r\n  </ng-container>\r\n</div>\r\n",
                        providers: [
                            {
                                provide: narikUiCore.NarikDynamicForm,
                                useExisting: core.forwardRef((/**
                                 * @return {?}
                                 */
                                function () { return NarikNgxDynamicForm; }))
                            }
                        ]
                    }] }
        ];
        /** @nocollapse */
        NarikNgxDynamicForm.ctorParameters = function () { return [
            { type: core.Injector },
            { type: core.ViewContainerRef }
        ]; };
        return NarikNgxDynamicForm;
    }(narikUiCore.NarikDynamicForm));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NarikNgxDynamicFormModule = /** @class */ (function () {
        function NarikNgxDynamicFormModule() {
        }
        NarikNgxDynamicFormModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [
                            common.CommonModule,
                            forms.FormsModule,
                            core$1.TranslateModule,
                            NarikNgxInputModule,
                            NarikNgxSelectModule,
                            NarikNgxCheckBoxModule,
                            NarikNgxRadioGroupModule,
                            NarikNgxAutoCompleteModule,
                            NarikNgxDatePickerModule,
                            narikCommon.NarikCommonModule
                        ],
                        declarations: [NarikNgxDynamicForm],
                        exports: [NarikNgxDynamicForm],
                        providers: []
                    },] }
        ];
        return NarikNgxDynamicFormModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NarikNgxDialogContainer = /** @class */ (function (_super) {
        __extends(NarikNgxDialogContainer, _super);
        function NarikNgxDialogContainer() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        /**
         * @return {?}
         */
        NarikNgxDialogContainer.prototype.ngOnInit = /**
         * @return {?}
         */
        function () { };
        NarikNgxDialogContainer.decorators = [
            { type: core.Component, args: [{
                        template: "",
                        animations: [animations.trigger("openClose", narikCore.DialogAnimationBody)],
                        styles: [".dialog-container{background-color:#fff;border-radius:5px;box-shadow:20px 20px 15px -7px rgba(0,0,0,.2),0 24px 38px 3px rgba(0,0,0,.14),0 9px 46px 8px rgba(0,0,0,.12)}"]
                    }] }
        ];
        return NarikNgxDialogContainer;
    }(narikCore.NarikDialogContainer));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NarikNgxInputDialog = /** @class */ (function () {
        function NarikNgxInputDialog() {
            this.entity = {};
            this.fields = [];
        }
        /**
         * @return {?}
         */
        NarikNgxInputDialog.prototype.ngOnInit = /**
         * @return {?}
         */
        function () { };
        NarikNgxInputDialog.decorators = [
            { type: core.Component, args: [{
                        template: "<div class=\"pr-2 pl-2\">\r\n  <narik-dynamic-form [model]=\"entity\" [fields]=\"fields\"></narik-dynamic-form>\r\n</div>\r\n"
                    }] }
        ];
        /** @nocollapse */
        NarikNgxInputDialog.ctorParameters = function () { return []; };
        return NarikNgxInputDialog;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NarikNgxMessageDialog = /** @class */ (function () {
        function NarikNgxMessageDialog() {
        }
        /**
         * @return {?}
         */
        NarikNgxMessageDialog.prototype.ngOnInit = /**
         * @return {?}
         */
        function () { };
        NarikNgxMessageDialog.decorators = [
            { type: core.Component, args: [{
                        template: "<div class=\"card p-2\">{{message | translate}}</div>\r\n"
                    }] }
        ];
        /** @nocollapse */
        NarikNgxMessageDialog.ctorParameters = function () { return []; };
        return NarikNgxMessageDialog;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ɵ0 = NarikNgxDialogContainer, ɵ1 = NarikNgxMessageDialog, ɵ2 = NarikNgxInputDialog;
    var NarikNgxDialogModule = /** @class */ (function () {
        function NarikNgxDialogModule() {
        }
        NarikNgxDialogModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [
                            common.CommonModule,
                            forms.FormsModule,
                            core$1.TranslateModule,
                            narikCommon.NarikCommonModule,
                            NarikNgxButtonModule,
                            NarikNgxDynamicFormModule
                        ],
                        declarations: [
                            NarikNgxDialogContainer,
                            NarikNgxInputDialog,
                            NarikNgxMessageDialog
                        ],
                        exports: [
                            NarikNgxDialogContainer,
                            NarikNgxInputDialog,
                            NarikNgxMessageDialog
                        ],
                        providers: [
                            {
                                provide: narikInfrastructure.DIALOG_CONTAINER,
                                useValue: ɵ0
                            },
                            {
                                provide: narikInfrastructure.DIALOG_MESSAGE_COMPONENT,
                                useValue: ɵ1
                            },
                            {
                                provide: narikInfrastructure.DIALOG_INPUT_COMPONENT,
                                useValue: ɵ2
                            }
                        ],
                        entryComponents: [
                            NarikNgxDialogContainer,
                            NarikNgxInputDialog,
                            NarikNgxMessageDialog
                        ]
                    },] }
        ];
        return NarikNgxDialogModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NarikNgxTreeview = /** @class */ (function (_super) {
        __extends(NarikNgxTreeview, _super);
        function NarikNgxTreeview(injector) {
            return _super.call(this, injector) || this;
        }
        Object.defineProperty(NarikNgxTreeview.prototype, "selectedItem", {
            get: /**
             * @return {?}
             */
            function () {
                return this._selectedItem;
            },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this._selectedItem = value;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} selectedNode
         * @return {?}
         */
        NarikNgxTreeview.prototype.addNode = /**
         * @param {?} selectedNode
         * @return {?}
         */
        function (selectedNode) {
            throw new Error("Method not implemented.");
        };
        /**
         * @param {?} selectedNode
         * @return {?}
         */
        NarikNgxTreeview.prototype.deleteNode = /**
         * @param {?} selectedNode
         * @return {?}
         */
        function (selectedNode) {
            throw new Error("Method not implemented.");
        };
        NarikNgxTreeview.decorators = [
            { type: core.Component, args: [{
                        selector: "narik-ngx-treeview narik-treeview",
                        template: ""
                    }] }
        ];
        /** @nocollapse */
        NarikNgxTreeview.ctorParameters = function () { return [
            { type: core.Injector }
        ]; };
        NarikNgxTreeview.propDecorators = {
            newNodeTitle: [{ type: core.Input }]
        };
        return NarikNgxTreeview;
    }(narikUiCore.NarikTreeview));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NarikNgxToolBar = /** @class */ (function (_super) {
        __extends(NarikNgxToolBar, _super);
        function NarikNgxToolBar(injector, viewContainerRef) {
            var _this = _super.call(this, injector, viewContainerRef) || this;
            _this.uniqueId = "";
            _this.uniqueId = "toolbar" + angular2Uuid.UUID.UUID();
            return _this;
        }
        NarikNgxToolBar.decorators = [
            { type: core.Component, args: [{
                        selector: "narik-toolbar , narik-ngx-toolbar",
                        template: "\r\n"
                    }] }
        ];
        /** @nocollapse */
        NarikNgxToolBar.ctorParameters = function () { return [
            { type: core.Injector },
            { type: core.ViewContainerRef }
        ]; };
        return NarikNgxToolBar;
    }(narikUiCore.NarikToolBar));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NarikNgxToolbarModule = /** @class */ (function () {
        function NarikNgxToolbarModule() {
        }
        NarikNgxToolbarModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [
                            common.CommonModule,
                            forms.FormsModule,
                            NarikNgxButtonModule,
                            core$1.TranslateModule
                        ],
                        declarations: [NarikNgxToolBar],
                        exports: [NarikNgxToolBar],
                        providers: []
                    },] }
        ];
        return NarikNgxToolbarModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NarikNgxTreeviewModule = /** @class */ (function () {
        function NarikNgxTreeviewModule() {
        }
        NarikNgxTreeviewModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [
                            common.CommonModule,
                            forms.FormsModule,
                            NarikNgxToolbarModule,
                            core$1.TranslateModule
                        ],
                        declarations: [NarikNgxTreeview],
                        exports: [NarikNgxTreeview],
                        providers: []
                    },] }
        ];
        return NarikNgxTreeviewModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NarikNgxCoreModule = /** @class */ (function () {
        function NarikNgxCoreModule() {
        }
        NarikNgxCoreModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule],
                        declarations: [],
                        exports: [],
                        providers: []
                    },] }
        ];
        return NarikNgxCoreModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NarikUiNgxBootstrapModule = /** @class */ (function () {
        function NarikUiNgxBootstrapModule() {
        }
        NarikUiNgxBootstrapModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [
                            core$1.TranslateModule,
                            NarikNgxAutoCompleteModule,
                            NarikNgxBusyIndicatorModule,
                            NarikNgxButtonModule,
                            NarikNgxCheckBoxModule,
                            NarikNgxCheckBoxListModule,
                            NarikNgxDataTableModule,
                            NarikNgxDatePickerModule,
                            NarikNgxDialogModule,
                            NarikNgxDynamicFormModule,
                            NarikNgxInputModule,
                            NarikNgxRadioGroupModule,
                            NarikNgxSelectModule,
                            NarikNgxToolbarModule,
                            NarikNgxTreeviewModule,
                            NarikNgxCoreModule
                        ],
                        declarations: [],
                        exports: [
                            core$1.TranslateModule,
                            NarikNgxAutoCompleteModule,
                            NarikNgxBusyIndicatorModule,
                            NarikNgxButtonModule,
                            NarikNgxCheckBoxModule,
                            NarikNgxCheckBoxListModule,
                            NarikNgxDataTableModule,
                            NarikNgxDatePickerModule,
                            NarikNgxDialogModule,
                            NarikNgxDynamicFormModule,
                            NarikNgxInputModule,
                            NarikNgxRadioGroupModule,
                            NarikNgxSelectModule,
                            NarikNgxToolbarModule,
                            NarikNgxTreeviewModule,
                            NarikNgxCoreModule
                        ],
                        providers: []
                    },] }
        ];
        return NarikUiNgxBootstrapModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @template T
     */
    var NarikUiListForm = /** @class */ (function (_super) {
        __extends(NarikUiListForm, _super);
        function NarikUiListForm(injector) {
            var _this = _super.call(this, injector) || this;
            _this.ds = [];
            _this.hasDataSource = false;
            return _this;
        }
        Object.defineProperty(NarikUiListForm.prototype, "isServerSide", {
            get: /**
             * @return {?}
             */
            function () {
                return this.config && this.config.isServerSideData ? true : false;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        NarikUiListForm.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            _super.prototype.ngOnInit.call(this);
            if (this.fields) ;
            if (this.config) {
                if (this.isServerSide) ;
            }
        };
        /**
         * @return {?}
         */
        NarikUiListForm.prototype.ngAfterViewInit = /**
         * @return {?}
         */
        function () { };
        /**
         * @param {?} result
         * @return {?}
         */
        NarikUiListForm.prototype.useData = /**
         * @param {?} result
         * @return {?}
         */
        function (result) {
            this.dataSource = (/** @type {?} */ (result.data));
        };
        /**
         * @protected
         * @param {?=} remoteDaraParams
         * @return {?}
         */
        NarikUiListForm.prototype.refresh = /**
         * @protected
         * @param {?=} remoteDaraParams
         * @return {?}
         */
        function (remoteDaraParams) {
            if (!this.isServerSide) {
                this.getEntities();
            }
        };
        __decorate([
            narikCore.NarikInject(core$1.TranslateService),
            __metadata("design:type", core$1.TranslateService)
        ], NarikUiListForm.prototype, "translateService", void 0);
        return NarikUiListForm;
    }(narikAppCore.NarikListForm));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @template T
     */
    var   /**
     * @template T
     */
    NarikUiDetailForm = /** @class */ (function (_super) {
        __extends(NarikUiDetailForm, _super);
        function NarikUiDetailForm(injector) {
            return _super.call(this, injector) || this;
        }
        return NarikUiDetailForm;
    }(narikAppCore.NarikDetailForm));

    exports.NarikNgxAutoComplete = NarikNgxAutoComplete;
    exports.NarikNgxAutoCompleteModule = NarikNgxAutoCompleteModule;
    exports.NarikNgxBusyIndicator = NarikNgxBusyIndicator;
    exports.NarikNgxBusyIndicatorModule = NarikNgxBusyIndicatorModule;
    exports.NarikNgxButtonComponent = NarikNgxButtonComponent;
    exports.NarikNgxButtonModule = NarikNgxButtonModule;
    exports.NarikNgxCheckBox = NarikNgxCheckBox;
    exports.NarikNgxCheckBoxList = NarikNgxCheckBoxList;
    exports.NarikNgxCheckBoxListModule = NarikNgxCheckBoxListModule;
    exports.NarikNgxCheckBoxModule = NarikNgxCheckBoxModule;
    exports.NarikNgxCoreModule = NarikNgxCoreModule;
    exports.NarikNgxDataTable = NarikNgxDataTable;
    exports.NarikNgxDataTableModule = NarikNgxDataTableModule;
    exports.NarikNgxDatePicker = NarikNgxDatePicker;
    exports.NarikNgxDatePickerModule = NarikNgxDatePickerModule;
    exports.NarikNgxDialogContainer = NarikNgxDialogContainer;
    exports.NarikNgxDialogModule = NarikNgxDialogModule;
    exports.NarikNgxDynamicForm = NarikNgxDynamicForm;
    exports.NarikNgxDynamicFormModule = NarikNgxDynamicFormModule;
    exports.NarikNgxInput = NarikNgxInput;
    exports.NarikNgxInputDialog = NarikNgxInputDialog;
    exports.NarikNgxInputModule = NarikNgxInputModule;
    exports.NarikNgxMessageDialog = NarikNgxMessageDialog;
    exports.NarikNgxRadioGroup = NarikNgxRadioGroup;
    exports.NarikNgxRadioGroupModule = NarikNgxRadioGroupModule;
    exports.NarikNgxSelect = NarikNgxSelect;
    exports.NarikNgxSelectModule = NarikNgxSelectModule;
    exports.NarikNgxToolBar = NarikNgxToolBar;
    exports.NarikNgxToolbarModule = NarikNgxToolbarModule;
    exports.NarikNgxTreeview = NarikNgxTreeview;
    exports.NarikNgxTreeviewModule = NarikNgxTreeviewModule;
    exports.NarikUiDetailForm = NarikUiDetailForm;
    exports.NarikUiListForm = NarikUiListForm;
    exports.NarikUiNgxBootstrapModule = NarikUiNgxBootstrapModule;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=narik-ui-ngx-bootstrap.umd.js.map
